Whamcloud - gitweb
LU-7110 tests: sanity-hsm.sh can erase all files on filesystem
[fs/lustre-release.git] / lustre / tests / sanity-hsm.sh
index 183a4d4..9f8ec9c 100755 (executable)
@@ -24,6 +24,7 @@ init_logging
 
 MULTIOP=${MULTIOP:-multiop}
 OPENFILE=${OPENFILE:-openfile}
+MMAP_CAT=${MMAP_CAT:-mmap_cat}
 MOUNT_2=${MOUNT_2:-"yes"}
 FAIL_ON_ERROR=false
 
@@ -102,7 +103,16 @@ init_agt_vars() {
        export HSMTOOL_EVENT_FIFO=${HSMTOOL_EVENT_FIFO:=""}
        export HSMTOOL_TESTDIR
        export HSMTOOL_BASE=$(basename "$HSMTOOL" | cut -f1 -d" ")
+       # $hsm_root/$HSMTMP Makes $hsm_root dir path less generic to ensure
+       # rm -rf $hsm_root/* is safe even if $hsm_root becomes unset to avoid
+       # deleting everything in filesystem, independent of any copytool.
+       export HSMTMP=${HSMTMP:-"shsm"}
+
        HSM_ARCHIVE=$(copytool_device $SINGLEAGT)
+
+       [ -z "${HSM_ARCHIVE// /}" ] && error "HSM_ARCHIVE is empty!"
+       HSM_ARCHIVE=$HSM_ARCHIVE/$HSMTMP
+
        HSM_ARCHIVE_NUMBER=2
 
        # The test only support up to 10 MDTs
@@ -144,15 +154,40 @@ get_mdt_devices() {
 }
 
 search_copytools() {
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
-       do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+       do_nodesv $hosts "pgrep -x $HSMTOOL_BASE"
 }
 
-search_and_kill_copytool() {
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
+kill_copytools() {
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
 
-       echo "Killing existing copytools on $agents"
-       do_nodesv $agents "killall -q $HSMTOOL_BASE" || true
+       echo "Killing existing copytools on $hosts"
+       do_nodesv $hosts "killall -q $HSMTOOL_BASE" || true
+}
+
+wait_copytools() {
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+       local wait_timeout=200
+       local wait_start=$SECONDS
+       local wait_end=$((wait_start + wait_timeout))
+
+       while ((SECONDS < wait_end)); do
+               sleep 2
+               if ! search_copytools $hosts; then
+                       echo "copytools stopped in $((SECONDS - wait_start))s"
+                       return 0
+               fi
+
+               echo "copytools still running on $hosts"
+       done
+
+       # try to dump Copytool's stack
+       do_nodesv $hosts "echo 1 >/proc/sys/kernel/sysrq ; " \
+                        "echo t >/proc/sysrq-trigger"
+
+       echo "copytools failed to stop in ${wait_timeout}s"
+
+       return 1
 }
 
 copytool_monitor_setup() {
@@ -218,6 +253,9 @@ copytool_setup() {
        local lustre_mntpnt=${2:-${MOUNT2:-$MOUNT}}
        local arc_id=$3
        local hsm_root=${4:-$(copytool_device $facet)}
+
+       [ -z "${hsm_root// /}" ] && error "copytool_setup: hsm_root empty!"
+
        local agent=$(facet_active_host $facet)
 
        if [[ -z "$arc_id" ]] &&
@@ -228,14 +266,16 @@ copytool_setup() {
 
        if $HSM_ARCHIVE_PURGE; then
                echo "Purging archive on $agent"
-               do_facet $facet "rm -rf $hsm_root/*"
+               do_facet $facet "rm -rf $hsm_root/$HSMTMP/*"
        fi
 
        echo "Starting copytool $facet on $agent"
-       do_facet $facet "mkdir -p $hsm_root" || error "mkdir '$hsm_root' failed"
+       do_facet $facet "mkdir -p $hsm_root/$HSMTMP/" ||
+                       error "mkdir '$hsm_root/$HSMTMP' failed"
        # bandwidth is limited to 1MB/s so the copy time is known and
        # independent of hardware
-       local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon --hsm-root $hsm_root"
+       local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon"
+       cmd+=" --hsm-root $hsm_root/$HSMTMP"
        [[ -z "$arc_id" ]] || cmd+=" --archive $arc_id"
        [[ -z "$HSMTOOL_UPDATE_INTERVAL" ]] ||
                cmd+=" --update-interval $HSMTOOL_UPDATE_INTERVAL"
@@ -274,31 +314,17 @@ copytool_cleanup() {
        trap - EXIT
        local agt_facet=$SINGLEAGT
        local agt_hosts=${1:-$(facet_active_host $agt_facet)}
-       local end_wait=$(( SECONDS + TIMEOUT ))
        local hsm_root=$(copytool_device $agt_facet)
+
+       [ -z "${hsm_root// /}" ] && error "copytool_cleanup: hsm_root empty!"
+
        local i
        local facet
        local param
        local -a state
 
-       do_nodesv $agt_hosts "pkill -INT -x $HSMTOOL_BASE" || return 0
-
-       while (( SECONDS < end_wait )); do
-               sleep 2
-               do_nodesv $agt_hosts "pgrep -x $HSMTOOL_BASE"
-               if [ $? -ne 0 ]; then
-                       echo "copytool is stopped on $agt_hosts"
-                       break
-               fi
-               echo "copytool still running on $agt_hosts"
-       done
-
-       if do_nodesv $agt_hosts "pgrep -x $HSMTOOL_BASE"; then
-               error "copytool failed to stop in ${TIMEOUT}s"
-       else
-               echo "copytool has stopped in " \
-                    "$((TIMEOUT - (end_wait - SECONDS)))s"
-       fi
+       kill_copytools $agt_hosts
+       wait_copytools $agt_hosts || error "copytools failed to stop"
 
        # Clean all CDTs orphans requests from previous tests that
        # would otherwise need to timeout to clear.
@@ -327,7 +353,6 @@ copytool_cleanup() {
                do_facet $facet "$LCTL set_param $param=${state[$i]}"
        done
 
-
        for ((i = 0; i < MDSCOUNT; i++)); do
                # Only check CDTs that we stopped in the first loop.
                [[ "${state[$i]}" =~ ^stop ]] && continue
@@ -341,7 +366,7 @@ copytool_cleanup() {
        done
 
        if do_facet $agt_facet "df $hsm_root" >/dev/null 2>&1 ; then
-               do_facet $agt_facet "rm -rf $hsm_root/*"
+               do_facet $agt_facet "rm -rf $hsm_root/$HSMTMP/*"
        fi
 }
 
@@ -786,14 +811,14 @@ parse_json_event() {
        echo $raw_event | python -c "$json_parser"
 }
 
-# populate MDT device array
-get_mdt_devices
-
 # initiate variables
 init_agt_vars
 
+# populate MDT device array
+get_mdt_devices
+
 # cleanup from previous bad setup
-search_and_kill_copytool
+kill_copytools
 
 # for recovery tests, coordinator needs to be started at mount
 # so force it
@@ -846,6 +871,23 @@ test_1() {
 }
 run_test 1 "lfs hsm flags root/non-root access"
 
+test_1a() {
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(make_small $f)
+
+       $LFS hsm_archive $f || error "could not archive file"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       # Release and check states
+       $LFS hsm_release $f || error "could not release file"
+       echo -n "Verifying released state: "
+       check_hsm_flags $f "0x0000000d"
+
+       $MMAP_CAT $f > /dev/null || error "failed mmap & cat release file"
+}
+run_test 1a "mmap & cat a HSM released file"
+
 test_2() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
@@ -1476,9 +1518,8 @@ test_12q() {
        $LFS hsm_release $f || error "could not release file"
        check_hsm_flags $f "0x0000000d"
 
-       search_and_kill_copytool
-       sleep 5
-       search_copytools && error "Copytool should have stopped"
+       kill_copytools
+       wait_copytools || error "copytool failed to stop"
 
        cat $f > /dev/null &
 
@@ -3138,7 +3179,7 @@ test_60() {
        local elapsed=$((finish_at - start_at))
 
        # Ensure that the progress update occurred within the expected window.
-       if [ $elapsed -lt $interval ]; then
+       if [ $elapsed -lt $((interval - 1)) ]; then
                error "Expected progress update after at least $interval seconds"
        fi
 
@@ -4595,6 +4636,66 @@ test_405() {
 }
 run_test 405 "archive and release under striped directory"
 
+test_406() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.64) ] &&
+               skip "need MDS version at least 2.7.64" && return 0
+
+       local fid
+       local mdt_index
+
+       copytool_setup
+       mkdir -p $DIR/$tdir
+       fid=$(make_small $DIR/$tdir/$tfile)
+       echo "old fid $fid"
+
+       $LFS hsm_archive $DIR/$tdir/$tfile
+       wait_request_state "$fid" ARCHIVE SUCCEED
+       $LFS hsm_release $DIR/$tdir/$tfile
+
+       # Should migrate $tdir but not $tfile.
+       $LFS mv -M1 $DIR/$tdir &&
+               error "migrating HSM an archived file should fail"
+
+       $LFS hsm_restore $DIR/$tdir/$tfile
+       wait_request_state "$fid" RESTORE SUCCEED
+
+       $LFS hsm_remove $DIR/$tdir/$tfile
+       wait_request_state "$fid" REMOVE SUCCEED
+
+       cat $DIR/$tdir/$tfile > /dev/null ||
+               error "cannot read $DIR/$tdir/$tfile"
+
+       $LFS mv -M1 $DIR/$tdir ||
+               error "cannot complete migration after HSM remove"
+
+       mdt_index=$($LFS getstripe -M $DIR/$tdir)
+       if ((mdt_index != 1)); then
+               error "expected MDT index 1, got $mdt_index"
+       fi
+
+       # Refresh fid after migration.
+       fid=$(path2fid $DIR/$tdir/$tfile)
+       echo "new fid $fid"
+
+       $LFS hsm_archive $DIR/$tdir/$tfile
+       wait_request_state "$fid" ARCHIVE SUCCEED 1
+
+       lctl set_param debug=+trace
+       $LFS hsm_release $DIR/$tdir/$tfile ||
+               error "cannot release $DIR/$tdir/$tfile"
+
+       $LFS hsm_restore $DIR/$tdir/$tfile
+       wait_request_state "$fid" RESTORE SUCCEED 1
+
+       cat $DIR/$tdir/$tfile > /dev/null ||
+               error "cannot read $DIR/$tdir/$tfile"
+
+       copytool_cleanup
+}
+run_test 406 "attempting to migrate HSM archived files is safe"
+
 test_500()
 {
        [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.92) ] &&